## START: Set by rpmautospec
## (rpmautospec version 0.2.5)
%define autorelease(e:s:pb:) %{?-p:0.}%{lua:
    release_number = 3;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{?dist}
## END: Set by rpmautospec

# Need to use GitHub archive for tests. This version was not tagged.
%global commit 804d5fd902809bae19e72a50917bd90ab032e174
%global forgeurl https://github.com/ofek/hatch

Name:           hatch
Version:        0.23.1
%forgemeta
Release:        %autorelease
Summary:        A modern project, package, and virtual env manager

License:        MIT or ASL 2.0
URL:            %{forgeurl}
Source0:        %{forgesource}

# Written for Fedora in groff_man(7) format based on --help output
Source100:      hatch.1
Source101:      hatch-build.1
Source102:      hatch-clean.1
Source103:      hatch-conda.1
Source104:      hatch-config.1
Source105:      hatch-env.1
Source106:      hatch-grow.1
Source107:      hatch-init.1
Source108:      hatch-install.1
Source109:      hatch-new.1
Source110:      hatch-pypath.1
Source111:      hatch-python.1
Source112:      hatch-release.1
Source113:      hatch-shed.1
Source114:      hatch-shell.1
Source115:      hatch-test.1
Source116:      hatch-use.1
Source117:      hatch-uninstall.1
Source118:      hatch-update.1

BuildArch:      noarch

BuildRequires:  python3-devel
BuildRequires:  git-core

# Required for tests but not present in the package metadata:
BuildRequires:  python3dist(parse)

Requires:  git-core

%description
Hatch is a modern, extensible Python project manager.

Features:

  · Standardized build system with reproducible builds by default
  · Robust environment management with support for custom scripts
  · Easy publishing to PyPI or other sources
  · Version management
  · Configurable project generation with sane defaults
  · Responsive CLI, ~2-3x faster than equivalent tools


%prep
%forgeautosetup
cp -p '%{SOURCE100}' '%{SOURCE101}' '%{SOURCE102}' '%{SOURCE103}' \
    '%{SOURCE104}' '%{SOURCE105}' '%{SOURCE106}' '%{SOURCE107}' \
    '%{SOURCE108}' '%{SOURCE109}' '%{SOURCE110}' '%{SOURCE111}' \
    '%{SOURCE112}' '%{SOURCE113}' '%{SOURCE114}' '%{SOURCE115}' \
    '%{SOURCE116}' '%{SOURCE117}' '%{SOURCE118}' .


%generate_buildrequires
%pyproject_buildrequires


%build
%pyproject_wheel


%install
%pyproject_install
%pyproject_save_files hatch
install -t '%{buildroot}%{_mandir}/man1' -D -p -m 0644 hatch.1 hatch-*.1


%check
# test_download_file needs internet
k="${k-}${k+ and }not test_download_file"
# test_env timeouts (on its own limit) in Koji
k="${k-}${k+ and }not test_env"
# test_grow is not compatible with the latest click:
# https://github.com/ofek/hatch/issues/99 (fixed for 1.0)
k="${k-}${k+ and }not test_grow"
# >           assert parsed['coverage_command'] == '\n\nafter_success:\n  - codecov'
# E           AssertionError: assert '\n\nafter_su...  - codecov\n' == '\n\nafter_su...\n  - codecov'
# E
# E
# E               after_success:
# E             -   - codecov
# E             +   - codecov
# E             ?            +
# TODO: what exactly is happening here? Adding a BR on python3dist(codecov)
# doesn’t make a difference.
k="${k-}${k+ and }not test_coverage_command"

%pytest -k "${k-}"


%files -f %{pyproject_files}
# pyproject_files handles LICENSE-* and AUTHORS.rst; verify with “rpm -qL -p …”
%doc COMMANDS.rst
%doc CONFIG.rst
%doc HISTORY.rst
%doc README.rst

%{_bindir}/hatch
%{_mandir}/man1/hatch.1*
%{_mandir}/man1/hatch-*.1*


%changelog
* Sun Feb 06 2022 Benjamin A. Beasley <code@musicinmybrain.net> 0.23.1-3
- Add man pages

* Fri Feb 04 2022 Benjamin A. Beasley <code@musicinmybrain.net> 0.23.1-2
- Add a few extra doc files

* Fri Feb 04 2022 Benjamin A. Beasley <code@musicinmybrain.net> 0.23.1-1
- Update to 0.23.1 (final pre-1.0 release)

* Fri Feb 04 2022 Benjamin A. Beasley <code@musicinmybrain.net> 0.23.0-15
- Port to pyproject-rpm-macros (“new guidelines”)

* Thu Jan 20 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.23.0-12
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Thu Jul 22 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.23.0-11
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Wed Jul 21 2021 Lumír Balhar <lbalhar@redhat.com> - 0.23.0-10
- Fix FTBFS in Fedora rawhide

* Fri Jun 04 2021 Python Maint <python-maint@redhat.com> - 0.23.0-9
- Rebuilt for Python 3.10

* Thu Jan 28 2021 Lumír Balhar <lbalhar@redhat.com> - 0.23.0-8
- Skip one more test

* Tue Jan 26 2021 Lumír Balhar <lbalhar@redhat.com> - 0.23.0-7
- Skip broken test (timeouts)

* Tue Jan 26 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.23.0-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Mon Jan 25 2021 Lumír Balhar <lbalhar@redhat.com> - 0.23.0-5
- Extend tests timeout

* Tue Jul 28 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.23.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Tue May 26 2020 Miro Hrončok <mhroncok@redhat.com> - 0.23.0-3
- Rebuilt for Python 3.9

* Wed Jan 29 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.23.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Mon Nov 04 2019 Lumír Balhar <lbalhar@redhat.com> - 0.23.0-1
- New upstream version 0.23.0

* Thu Oct 03 2019 Miro Hrončok <mhroncok@redhat.com> - 0.20.0-12
- Rebuilt for Python 3.8.0rc1 (#1748018)

* Mon Aug 19 2019 Miro Hrončok <mhroncok@redhat.com> - 0.20.0-11
- Rebuilt for Python 3.8

* Thu Jul 25 2019 Fedora Release Engineering <releng@fedoraproject.org> - 0.20.0-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Tue Feb 12 2019 Lumír Balhar <lbalhar@redhat.com> - 0.20.0-9
- Fix dependency name python3-twine → twine

* Fri Feb 01 2019 Fedora Release Engineering <releng@fedoraproject.org> - 0.20.0-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.20.0-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Wed Jun 27 2018 Lumír Balhar <lbalhar@redhat.com> - 0.20.0-6
- Bump release to rebuild in side tag f29-python with Python 3.7

* Wed Jun 27 2018 Lumír Balhar <lbalhar@redhat.com> - 0.20.0-5
- Fix FTBFS due to failing tests which newly requires internet connection

* Tue Jun 19 2018 Miro Hrončok <mhroncok@redhat.com> - 0.20.0-4
- Rebuilt for Python 3.7

* Wed Feb 07 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.20.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Tue Dec 05 2017 Lumir Balhar <lbalhar@redhat.com> - 0.20.0-2
- Backslashes removed from description

* Wed Nov 15 2017 Lumir Balhar <lbalhar@redhat.com> - 0.20.0-1
- New upstream version
- New dependencies python-adduserpath (module userpath) and python-toml
- One test skipped due to internet connection requirement

* Wed Sep 13 2017 Lumir Balhar <lbalhar@redhat.com> - 0.11.0-1
- Initial package.

